"""LCM type definitions
This file automatically generated by lcm.
DO NOT MODIFY BY HAND!!!!
"""

try:
    import cStringIO.StringIO as BytesIO
except ImportError:
    from io import BytesIO
import struct

class imu_t(object):
    __slots__ = ["timestamp", "theta_z", "theta_y", "theta_x", "mag_x", "mag_y", "mag_z", "acc_x", "acc_y", "acc_z", "theta_x_d", "theta_y_d", "theta_z_d"]

    def __init__(self):
        self.timestamp = 0.0
        self.theta_z = 0.0
        self.theta_y = 0.0
        self.theta_x = 0.0
        self.mag_x = 0.0
        self.mag_y = 0.0
        self.mag_z = 0.0
        self.acc_x = 0.0
        self.acc_y = 0.0
        self.acc_z = 0.0
        self.theta_x_d = 0.0
        self.theta_y_d = 0.0
        self.theta_z_d = 0.0

    def encode(self):
        buf = BytesIO()
        buf.write(imu_t._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf):
        buf.write(struct.pack(">ddddddddddddd", self.timestamp, self.theta_z, self.theta_y, self.theta_x, self.mag_x, self.mag_y, self.mag_z, self.acc_x, self.acc_y, self.acc_z, self.theta_x_d, self.theta_y_d, self.theta_z_d))

    def decode(data):
        if hasattr(data, 'read'):
            buf = data
        else:
            buf = BytesIO(data)
        if buf.read(8) != imu_t._get_packed_fingerprint():
            raise ValueError("Decode error")
        return imu_t._decode_one(buf)
    decode = staticmethod(decode)

    def _decode_one(buf):
        self = imu_t()
        self.timestamp, self.theta_z, self.theta_y, self.theta_x, self.mag_x, self.mag_y, self.mag_z, self.acc_x, self.acc_y, self.acc_z, self.theta_x_d, self.theta_y_d, self.theta_z_d = struct.unpack(">ddddddddddddd", buf.read(104))
        return self
    _decode_one = staticmethod(_decode_one)

    _hash = None
    def _get_hash_recursive(parents):
        if imu_t in parents: return 0
        tmphash = (0x90799bb35473a707) & 0xffffffffffffffff
        tmphash  = (((tmphash<<1)&0xffffffffffffffff)  + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash
    _get_hash_recursive = staticmethod(_get_hash_recursive)
    _packed_fingerprint = None

    def _get_packed_fingerprint():
        if imu_t._packed_fingerprint is None:
            imu_t._packed_fingerprint = struct.pack(">Q", imu_t._get_hash_recursive([]))
        return imu_t._packed_fingerprint
    _get_packed_fingerprint = staticmethod(_get_packed_fingerprint)

